/// <reference types="node" />
import BigNumber from 'bignumber.js';
export interface IToFromBufferOpts {
    /**
     * Size of the buffer
     */
    size?: 'auto' | number;
    /**
     * Encoding type.
     */
    endian?: 'big' | 'little';
}
/**
 * Calculates BigNumber from buffer representation
 * @param {Buffer} buf
 * @param {ToFromBufferOpts} opts
 */
export declare const bigNumberFromBuffer: (buf: Buffer, opts?: IToFromBufferOpts) => BigNumber;
/**
 * Exports bignumber to buffer.
 * @returns {Buffer}
 */
export declare const bigNumberToBuffer: (bignum: BigNumber, opts?: IToFromBufferOpts) => Buffer;
