"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var bignumber_1 = require("./bignumber");
var sha256_1 = require("./sha256");
/**
 * Derive an address from the public key
 * @param {string} publicKey publicKey to derive address from
 * @param {string} suffix a suffix character
 * @returns {string} the calculated address
 */
exports.deriveDPOSAddress = function (publicKey, suffix) {
    var hash = sha256_1.toSha256(new Buffer(publicKey, 'hex'));
    var temp = new Buffer(8);
    for (var i = 0; i < 8; i++) {
        temp[i] = hash[7 - i];
    }
    return "" + bignumber_1.bigNumberFromBuffer(temp).toString() + suffix;
};
