"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var trxTypes_1 = require("../trxTypes");
exports.createTransactionFromOBJ = function (tx) {
    var txObj;
    if (tx.type === 0 /*Send*/) {
        txObj = new trxTypes_1.SendTx();
    }
    else if (tx.type === 1 /* Create second signature */) {
        txObj = new trxTypes_1.CreateSignatureTx(tx.asset);
    }
    else if (tx.type === 2 /* Register Delegate */) {
        txObj = new trxTypes_1.DelegateTx(tx.asset);
    }
    else if (tx.type === 3 /* Vote */) {
        txObj = new trxTypes_1.VoteTx(tx.asset);
    }
    else if (tx.type === 4 /* Create Multisig account */) {
        txObj = new trxTypes_1.MultiSignatureTx(tx.asset);
    }
    if (typeof (txObj) === 'undefined') {
        throw new Error("Transaction " + tx.type + " is not supported");
    }
    Object.keys(tx)
        .filter(function (k) { return typeof (tx[k]) !== 'undefined'; })
        .forEach(function (k) { return txObj[k] = tx[k]; });
    return txObj;
};
